# Copyright (C) 2010-2023 Apple Inc. All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1.  Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
# 2.  Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

messages -> DrawingArea NotRefCounted {
#if USE(COORDINATED_GRAPHICS) || USE(TEXTURE_MAPPER)
    UpdateGeometry(WebCore::IntSize size) -> ()
    TargetRefreshRateDidChange(unsigned rate)
    SetDeviceScaleFactor(float deviceScaleFactor)
    ForceUpdate()
#endif

    DisplayDidRefresh()

#if PLATFORM(COCOA)
    UpdateGeometry(WebCore::IntSize viewSize, std::optional<WebKit::VisibleContentRectUpdateInfo> info, bool flushSynchronously, MachSendRight fencePort) -> ()
    SetDeviceScaleFactor(float deviceScaleFactor)
    SetColorSpace(struct std::optional<WebCore::DestinationColorSpace> colorSpace)
    SetViewExposedRect(std::optional<WebCore::FloatRect> viewExposedRect)

    AcceleratedAnimationDidStart(WebCore::PlatformLayerIdentifier layerID, String key, MonotonicTime startTime)
    AcceleratedAnimationDidEnd(WebCore::PlatformLayerIdentifier layerID, String key)
    
    DispatchAfterEnsuringDrawing() -> () CallWithReplyID
#endif

#if USE(GRAPHICS_LAYER_WC)
    UpdateGeometryWC(uint64_t backingStoreStateID, WebCore::IntSize viewSize)
#endif

#if PLATFORM(COCOA) || PLATFORM(GTK)
    AdjustTransientZoom(double scale, WebCore::FloatPoint origin)
    CommitTransientZoom(double scale, WebCore::FloatPoint origin)
#endif
}
